﻿#Import-Module sqlserver

$SQLCloneServer= 'http://win-3srg45gbf97:14145'
Connect-SqlClone -ServerUrl $SQLCloneServer

$BackupFolder = Get-SqlCloneBackupLocation -Path 'c:\backup'
$ImageDestination = Get-SqlCloneImageLocation -Path 'c:\bu'
$DbName = 'MovieManagement'


#Create a copy of the database from the backup
New-SqlCloneImage -Name $DbName -BackupLocation $BackupFolder -BackupFileName 'mm.bak' -Destination $ImageDestination | Wait-SqlCloneOperation
$RawImage = Get-SqlCloneImage -Name $DbName
$SqlInstance = Get-SqlCloneSqlServerInstance -MachineName 'win-3srg45gbf97' -InstanceName 'dojo'
New-SqlClone -Image $RawImage -Name "$($DbName)Dirty" -Location $SqlInstance | Wait-SqlCloneOperation


#Clean data manually
$CleanCommand = "UPDATE dbo.Agent SET EmailAddress = 'NoEmail@example.com';"
Invoke-Sqlcmd -Query $CleanCommand -ServerInstance 'WIN-3SRG45GBF97\dojo' -Database "$($DbName)Dirty"
$FixSecurity = 'DROP USER Sue;'
Invoke-Sqlcmd -Query $FixSecurity  -ServerInstance 'WIN-3SRG45GBF97\dojo' -Database "$($DbName)Dirty"


#Create a new image from clean database
New-SqlCloneImage -Name "$($DbName)Clean" -SqlServerInstance $SqlInstance -DatabaseName "$($DbName)Dirty" -Destination $ImageDestination | Wait-SqlCloneOperation
$CleanImage = Get-SqlCloneImage -Name "$($DbName)Clean"


#Create multiple Development databases
$x = 1
do{
New-SqlClone -Image $CleanImage -Name "$($DbName)Dev$($x)" -Location $SqlInstance | Wait-SqlCloneOperation
Write-Output "Creating Dev Clone #$x"
$x += 1}
until($x.Equals(10))



#CleanUp, remove the prep db and remove any copies of prod
$RawClone = Get-SqlClone -Name "$($DbName)Dirty"
Remove-SqlClone -Clone $RawClone | Wait-SqlCloneOperation
Remove-SqlCloneImage -Image $RawImage | Wait-SqlCloneOperation