--Dynamic Data Masking
USE MovieManagement;







SELECT a.SocialSecurityNumber
FROM dbo.Agent AS a;







ALTER TABLE dbo.Agent
ALTER COLUMN SocialSecurityNumber
ADD MASKED WITH(FUNCTION='partial(4,"XX-XXXX",0)');










CREATE USER Tim WITHOUT LOGIN;

GRANT SELECT ON dbo.Agent TO Tim;

EXECUTE AS USER = 'Tim';
SELECT a.SocialSecurityNumber
FROM dbo.Agent AS a;
REVERT;










CREATE USER Sue WITHOUT LOGIN;

GRANT SELECT ON dbo.Agent TO Sue;
GRANT UNMASK TO Sue;

EXECUTE AS USER = 'Sue';
SELECT a.SocialSecurityNumber
FROM dbo.Agent AS a;
REVERT;










BACKUP DATABASE MovieManagement TO DISK = 'c:\backup\mm.bak' WITH INIT;




RESTORE DATABASE MovieManagementStaging
FROM DISK = 'c:\backup\mm.bak'
WITH MOVE 'MovieManagement'
     TO 'c:\data\mm_staging.mdf',
     MOVE 'MovieManagement_log'
     TO 'c:\data\mm_staging.ldf',
     REPLACE,
     RECOVERY;







USE MovieManagementStaging;
GO


EXECUTE AS USER = 'Tim';
SELECT a.SocialSecurityNumber
FROM dbo.Agent AS a;
REVERT;

EXECUTE AS USER = 'Sue';
SELECT a.SocialSecurityNumber
FROM dbo.Agent AS a;
REVERT;







--dbcc clonedb
DBCC CLONEDATABASE(MovieManagement, MovieManagementCopy);


--turn on execution plans
USE MovieManagementCopy;
GO
SELECT COUNT(*)
FROM dbo.Agent AS a;









USE MovieManagement;
GO
SELECT *
FROM dbo.Agent AS a
JOIN dbo.Resource AS r
   ON r.AgentId = a.AgentId
WHERE r.LastName LIKE 'Ham%';






USE MovieManagementCopy;
GO
SELECT *
FROM dbo.Agent AS a
JOIN dbo.Resource AS r
   ON r.AgentId = a.AgentId
WHERE r.LastName LIKE 'Ham%';





USE master;
GO
DROP DATABASE MovieManagementCopy;
GO


DBCC CLONEDATABASE(MovieManagement, MovieManagementCopy);
GO


USE MovieManagementCopy;
GO
SELECT *
FROM dbo.Agent AS a
JOIN dbo.Resource AS r
   ON r.AgentId = a.AgentId
WHERE r.LastName LIKE 'Ham%';









BACKUP DATABASE MovieManagementCopy
TO DISK = 'c:\backup\mmc.bak'
WITH INIT;






RESTORE DATABASE MovieManagementCopyOfCopy
FROM DISK = 'c:\backup\mm.bak'
WITH MOVE 'MovieManagement'
     TO 'c:\data\mm_coc.mdf',
     MOVE 'MovieManagement_log'
     TO 'c:\data\mm_coc.ldf',
     REPLACE,
     RECOVERY;





SELECT qsqt.query_sql_text
FROM sys.query_store_query_text AS qsqt;






--in order to eliminate Query Store Info
DBCC CLONEDATABASE(MovieManagement, MoviewManagementQSFree) WITH NO_QUERYSTORE;


USE MoviewManagementQSFree;
GO
SELECT qsqt.query_sql_text
FROM sys.query_store_query_text AS qsqt;



--less attractive, but still useful
DBCC CLONEDATABASE(MovieManagement, MovieManagementStatsFree) WITH NO_STATISTICS














--CustomData
--Run CusttomDataLoad.ps1 first
USE MovieManagementQA;
GO
SELECT *
FROM dbo.Movie AS m;













--Manual Masking
--Run ManualMasking.ps1 first
--turn off exec plans
USE MovieManagementDev1;
GO
EXECUTE AS USER = 'Tim';
SELECT a.EmailAddress,
       a.SocialSecurityNumber
FROM dbo.Agent AS a;
REVERT;

USE MovieManagementDev2;
GO
UPDATE dbo.Agent
SET EmailAddress = 'grant@scarydba.com'
WHERE AgentId = 42;

EXECUTE AS USER = 'Tim';
SELECT a.EmailAddress,
       a.SocialSecurityNumber
FROM dbo.Agent AS a
WHERE a.AgentId = 42;
REVERT;

USE MovieManagementDev6;
GO
EXECUTE AS USER = 'Tim';
SELECT a.EmailAddress,
       a.SocialSecurityNumber
FROM dbo.Agent AS a
WHERE a.AgentId = 42;
REVERT;


--don't forget
USE master;
--Run ManualMasking_Cleanup.ps1


/*
--Cleanup
USE MovieManagement;
GO
ALTER TABLE dbo.Agent
ALTER COLUMN SocialSecurityNumber DROP MASKED;

DROP USER Tim;
DROP USER Sue;


DROP STATISTICS dbo.Resource._WA_Sys_00000002_21B6055D;
DROP STATISTICS dbo.Resource._WA_Sys_00000005_21B6055D;


USE master;
GO
DROP DATABASE MovieManagementStaging;
DROP DATABASE MovieManagementCopy;
DROP DATABASE MovieManagementCopyOfCopy;
DROP DATABASE MovieManagementQA;
DROP DATABASE MoviewManagementQSFree
DROP DATABASE MovieManagementStatsFree
*/

